(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.developpez.com/pascal/ $$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
   Le programme  Liste  est un programme de Haypo qui permet de consulter 
 des listes au format propritaire '.lst'. Pour connatre les touches qui   
 permettent d'utilisez cet utilitaire, tapez la touche 'F1' pendant que     
 vous l'utilisez.                                                           
                                                                            
****************************************************************************
******** Pour plus informations consultez le fichier 'Liste.txt' ***********
****************************************************************************
Ĵ
  Facults futures                                                        
                                                        
                                                                            
 Attention "future" signifit "en cours de dveloppement" mais ce dvelop-   
 pement peut tre trs long ou ne jamais aboutir. Si vous pouvez m'aider   
 ajouter ces facults, envoyez moi un email : haypo@ifrance.com.            
                                                                            
 * Barre de dfiliment 'potable' pour la liste des dfinions et la dfini-  
   tion.                                                                    
 * Utilisation d'un fichier de configuration o serait stock le nom des    
   diffrentes listes.                                                      
*)

{$A+: Utilise des adresses paire (plus rapide)                               }
{$B+: Optimise les valuations logiques                                      }
{$D-: N'insre pas d'informations pour le dboggage                          }
{$G+: Utilise les instructions du 286 (SHL/SHR/ENTER/LEAVE)                  }
{$I-: Ne teste pas les erreurs d'entre/sortie                               }
{$N-: N'utilise pas le co-processeur arithmtique                            }
{$Q-: Ne teste pas les erreurs de dbordement (Word(65535+1) par exemple)    }
{$R-: Ne teste pas les erreurs de domaine (Tableau, ex: EcrnTxt[4050])       }
{$S-: Ne teste pas le dbordement de la pile (8192 octets suffisent)         }
{$X+: Ne demande pas de variable pour stocker le rsultat d'une fonction     }

{$M 4096,0,655360: Demande toute la mmoire allouable dynamiquement}

uses
  Clavier,    { Interface utilisateur                                        }
  Convert,    { Convertion entre les formats dcimal, binaire, hxad., ...   }
  EcranTxt,   { Ecrit du texte en couleur                                    }
  GestFich,   { Gestion de fichiers : Ouverture, cration, taille, erreur,...}
  GestStrg,   { Gestion des chaines de caractres (ConvertitMajuscule)       }
  OuvrFich,   { Ouverture de fichier avec gestion                            }
              { des erreurs                                                  }
  OptVideo,   { Options spciales de vido (DebutAffichage)                  }
  StopProg,   { Stoppe le programme avec un message d'erreur standardis     }
  XMS;        { Gestion de la mmoire tendue (+ de 640Ko)                   }

const
  Version = '1.5.4';
  Email   = 'haypo@ifrance.com';
  PageWeb = 'http://www.developpez.com/pascal/';

  { Liste }
  VerFormatLst11 = 1 +1 shl 8;    { Format LST version 1.1                   }
  VerFormatLst   = 1 +2 shl 8;    { Format LST version 1.2                   }
  NbrListe = 8;                   { Nombre de listes                         }
  NomFichListe : array[0..NbrListe-1] of string[80] = (   { Nom des fichiers }
  'port','int','runtime','int10h','int15h','int16h','int21h','int33h');{ .lst}

  { Dfinitions }
  NbrDefParListeMax = 500;        { Nombre de dfinitions maximum par liste  }

type
  TexteDAide = array[1..23] of record X: shortint; Coul: byte; txt: string[76] end;

  { Dfinition }
  UneDefinition = record
    Index,              { Index de la dfinition }
    Ofst,               { Offset de la dfinition dans le grand tampon de }
                        { toutes les dfintitions (Liste.TouteDef) }
    Long: word;         { Longueur de la dfinition }
  end;
  Definition = array[0..NbrDefParListeMax] of UneDefinition;

  PtrDef = ^Definition;

  ListeType = record
    NbrDef: word;                      { Nombre de dfinitions               }
    Version: word;                     { Version X shr 8.Y                   }
    ModeHexa,Mode16b,Zero: boolean;
    Nom,TxtPresentDef: string[80];
    Def: PtrDef;
    TailleMemAlloue: Word;             { Nombre d'octets allous             }
    DefCharge,TouteDefCharge: boolean;

    Taille: word;                      { Taille du tampon allou             }
    LongTxtIntro: word;                { Longueur de texte d'introduction    }
                                       { (stock dans TouteDefHdlXMS         }
    TouteDefHdlXMS: word;              { Texte d'introduction + toutes les   }
                                       { dfinitions                         }
  end;

  { Tampon }
  TypeTampon = array[0..$FFFE] of byte;
  PtrTampon  = ^TypeTampon;

const
  { Mmoire }
  NbrLigneDefMax = 300;           { Nombre de lignes qu'une dfinition peut  }
                                  { contenir au maximum ( l'cran)          }

  { Clavier }
  _RETOUR = #8;              { Touche retour chariot (au dessus de entre) }
  _DEBUT  = #199;            { Touche aller au dbut }
  _FIN    = #207;              { Touche aller  la fin }
  _TAB    = #9;                   { Touche tabulation }
  ChHexa : string = 'ABCDEFH';    { Caractres spcifique des nombres }
                                  { hexadcimaux }

  TxtIntrouvable = '(inconnu, Liste v'+Version+' ...)';   { Texte renvoy si }
                                            { la dfinition est introuvalble }

  { Couleurs }                    { Couleur du : }
  CoulFond        =  7+0*16;      { Fond                                     }
  CoulActif       = 15+1*16;      { Element actif                            }
  CoulDefSelect   = 14+4*16;      { Dfinition slectionne dans la liste    }
  CoulCapture     =  7+0*16;      { Capture d'un index                       }
  CoulTxtBas      = 14+2*16;      { texte du bas                             }
  CoulMenuListe   = 15+3*16;      { Menu prsentant les diffrentes listes   }
  CoulMenuSelect  = 15+3*16;      { Slection dans ce menu                   }
  CoulSepInt      = 14+2*16;      { Couleur des sparations du texte dans les}
                                  { dfinitions de type interruption         }
  CoulBarreDfl    =  8+3*16;      { la barre de dfilement                   }
  CoulCurBarDfl   = 15+7*16;      { curseur de la barre de dfilement        }
  CoulCadrHaut    = 11+3*16;      { cadre de la barre du haut et du bas      }
  CoulCadrCentr   =  7+1*16;      { cadre du centre de l'cran (cadre fin)   }
  CoulCadrBas     = 10+2*16;      { cadre du bas                             }

  { Position }
  PosCaptX = 0;                   { X de la capture                          }
  PosCaptY = 2;                   { Y de la capture                          }
  CaptLarg = 7;                   { Largueur du cadre de capture             }
  PosPrstX = PosCaptX+CaptLarg+1; { X du texte de prsentation               }
  PrstLarg = 80-PosPrstX;         { Largeur du texte de prsentation         }
  PosDefX  = PosCaptX+CaptLarg+1; { X de la dfinition                       }
  PosDefY  = PosCaptY+2;          { Y de la dfinition                       }
  DefLarg  = 80-PosDefX;          { Largeur du cadre de dfinition           }
  DefYmax  = 25-2;                { Y maximum des dfinitions.               }
                                  { Le texte n'est pas affich  l'cran si  }
                                  { la coordonne Y dpasse cette valeur.    }
  DefHaut  = DefYmax-PosDefY;     { Y maximum des dfinitions.               }
                                  { Le texte n'est pas affich  l'cran si  }
                                  { la coordonne Y dpasse cette valeur.    }

  { Tampon }
  OctetLigneDefEcran = DefLarg shl 1;  { Nombre d'octet par ligne de         }
                                  { dfinition  l'cran                     }

  { Les deux aides  la navigation (touches du clavier) }
  AideGenerale: TexteDAide = (
(X: 0;Coul: 0;Txt:''),
(X:-1;Coul:14;Txt:'Touches utilises'),
(X:-1;Coul:14;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'0..9         : Sert  entrer l''index dcimal d''une dfinition'),
(X: 1;Coul:15;Txt:'0..9 et A..F : Sert  entrer l''index hxadcimal d''une dfinition'),
(X: 1;Coul:11;Txt:'> Le mode hxidcimal se distingue du mode dcimal par la prsence d''un ''h'''),
(X: 1;Coul:15;Txt:'Entre       : Valider la capture'),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'Haut, bas    : Sert  se dplacer dans la liste des dfinitons'),
(X: 1;Coul:15;Txt:'Page haut/bas: Sert  se dplacer rapidement dans cette liste'),
(X: 1;Coul:15;Txt:'Dbut, fin   : Sert  se dplacer au dbut /  la fin de cette liste'),
(X: 1;Coul:15;Txt:'Gauche       : Passe de la dfinition  la liste des dfinitons (si actif)'),
(X: 1;Coul:15;Txt:'Droite       : Passe de la liste des dfinitons  la dfinition (si actif)'),
(X:16;Coul:11;Txt:'(sont actifs si la dfinition dpasse du cadre)'),
(X: 1;Coul:15;Txt:'Entre       : Valide la dfiniton slectionne (si aucune capture en cours)'),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'F1     : Affiche l''aide'),
(X: 1;Coul:15;Txt:'Espace : Affiche le menu des listes'),
(X: 1;Coul:15;Txt:'Echape : Quitte  Liste '+Version+' '),
(X: 0;Coul: 0;Txt:''),
(X:-1;Coul: 7;Txt:'- Enfoncez une touche pour revenir -'),
(X: 0;Coul: 0;Txt:''));

  AideMenuListe: TexteDAide = (
(X: 0;Coul: 0;Txt:''),
(X: 5;Coul:14;Txt:'Touches utilises'),
(X: 5;Coul:14;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'Haut, bas           : Sert  se dplacer dans le menu des listes'),
(X: 1;Coul:15;Txt:'Page haut, page bas : Sert  se dplacer rapidement dans ce menu'),
(X: 1;Coul:15;Txt:'Dbut, fin          : Sert  se dplacer au dbut /  la fin de ce menu'),
(X: 1;Coul:15;Txt:'Entre              : Valide la liste slectionne'),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'F1 ........ : Affiche l''aide'),
(X: 1;Coul:15;Txt:'Echape .... : Quitte  Liste '+Version+' '),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X:-1;Coul: 7;Txt:'- Enfoncez une touche pour revenir -'));

var
  { Liste }
  Liste: array[0..NbrListe-1] of ListeType;
  TmpListe: ListeType;
  DefIndex,SauveDefIndex,ListeIndex: word;

  { Fichier }
  F: File;
  Tampon : record
    Debut,                        { Position de dbut du texte dans le tampon}
    Long,                         { Longueur du texte                        }
    Ofst,                         { Offset (dplacement) du tampon           }
    Max   : word;                 { Offset maximum du tampon                 }
    Charge: boolean;              { Le tampon est en mmoire ?               }
    Src   : PtrTampon;            { Tampon de 65Ko de lecture                }
  end;

  { Tampon }
  LibereMemAlloueLance: Boolean;  { La procdure 'LibereMemAlloue' a dj    }
                                  { t lance ? (vite de tourner en rond   }
                                  { avec la procdure 'ErreurXms')           }
  TamponEcran: record
    Handle: Word;                 { Le handle XMS du tampon                  }
    Actif:  Boolean;              { La dfinition dpasse l'cran ?          }
    Y: Word;                      { Coordonne Y actuelle                    }
    Ymax: Word;                   { Valeur maximale de Y                     }
    NbrLigne: Word;               { Nombre de ligne dans le tampon           }
    TmpLigne: Array[0..OctetLigneDefEcran-1] of byte; { Tampon d'une ligne   }
  end;

  { Navigation }
  NavigDsDef: Boolean;            { Navigue dans la dfinition ? Sinon la    }
                                  { navigation en est dans la liste des      }
                                  { dfinitions.                             }
  DefSelect: Byte;                { Index de la dfinition slectionne      }

  { Autre }
  TmpL: LongInt;
  Txt,TmpTxt,SauveTxt: String;
  PreTxt: string[3];
  TmpO: byte;
  index,vram,i,ix,iy,TmpM: word;
  erreur,TmpI: integer;
  min,max,x,NCaractMax,coul,IntIndex: byte;
  FinCapture: boolean;
  key,ch: char;
  DefIY: Byte;

procedure LibereMemAlloue; forward;

procedure TestErreurXms (txt: string); begin
  if ErreurXms=0 then exit;

  EcriTxc (-1,-1,'ERREUR XMS - Pressez une touche',14+4*16); LitTouche;

  InitModeTxt;
  EcriTcr ('Erreur lors de '+txt+' (n'+Hex8z(ErreurXms)+') :',12);
  EcriTcr ('> '+TxtErreurXms,15);
  EcriTr ('');
  EcriTcr ('Info pour le deboggage :',13);
  with CopieXms do begin
    Ecrit ('Taille = '); EcriTncr (Taille,10);
    Ecrit ('SrcHdl = '); EcriTncr (SrcHdl,10);
    Ecrit ('SrcOfs = '); EcriTnc (SrcOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(SrcOfs shr 16)+':'+Hex16z(SrcOfs and $FFFF),10); EcriTr (')');
    Ecrit ('DstHdl = '); EcriTncr (DstHdl,10);
    Ecrit ('DstOfs = '); EcriTnc (DstOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(DstOfs shr 16)+':'+Hex16z(DstOfs and $FFFF),10); EcriTr (')');
    Ecrit ('Mmoire XMS libre = '); EcriTnc (MemXmsLibre,10); EcriTr (' Ko');
  end;
  EcriTr ('');
  EcriTc ('--- Pressez une touche pour finir ---',15+2*16); LitTouche;
  EcriTxhc (0,EcranY,80,' ',7); PosY (EcranY-1);
  LibereMemAlloue;
  Halt;
end;

procedure LibereMemAlloue; var X: byte; begin
  { Mmoire dj rendue ? }
  if LibereMemAlloueLance then exit;
  LibereMemAlloueLance := TRUE;

  CoulTxt := 7+0*16;
  EcriT ('Libre les tampons : '); X := EcranX;
  CoulTxt := 11+0*16;

  { Le tampon cran }
  with TamponEcran do if Handle<>0 then begin
    Ecrit ('cran');
    RendMemXms (Handle);
    TestErreurXms ('la libration du tampon cran');
    Handle := 0;
  end;

  { La liste temporaire }
  with TmpListe do begin
    if DefCharge then begin
      Ecrit (', ListeTmp');
      FreeMem (Def,TailleMemAlloue);
    end;

    if TouteDefCharge then begin
      if not DefCharge then Ecrit (', ListeTmpXMS');
      RendMemXms (TouteDefHdlXMS);
      TestErreurXms ('la libration de la liste temporaire');
    end;
  end;

  { Les listes }
  for i := 0 to NbrListe-1 do with Liste[i] do begin
    if DefCharge then begin
      Ecrit (', L');
      EcriTn (i);

      FreeMem (Def,TailleMemAlloue);
    end;

    if TouteDefCharge then begin
      if not DefCharge then EcriTn (i);
      RendMemXms (TouteDefHdlXMS);
      TestErreurXms ('la libration de la liste temporaire');
    end;
  end;

  { Le tampon de 65Ko }
  with Tampon do if Charge then begin
    if EcranX<>X then Ecrit (', ');
    EcriTc ('Tmp65Ko',11);
    FreeMem (Src,$FFFF);
    Charge := FALSE;
  end;

  if EcranX<>X then begin
    EcriT (' -> ');
    EcriTcr ('russi !',14);
  end else EcriTr ('(rien  rendre)');
end;

procedure Fin; begin
  move (EcrnTxt,SavEcrnTxt,SizeOf(EcranTxt80x25));

  { Affiche un cadre demandant la confirmation de quitter }
  TmpTxt := 'Etes-vous bien sr de vouloir quitter (O/N) ? ';
  DessineCadre (-1,-1,length(TmpTxt)+5,5,_PLEIN+_DOUBLE,12+4*16);
  EcriTxc (EcranX+1,EcranY+1,TmpTxt,14+4*16);

  key := UpCase(LitTouche);
  FinCapture := (key='O') or (key='Q');

  move (SavEcrnTxt,EcrnTxt,SizeOf(EcranTxt80x25));

  if not FinCapture then begin PosXY (0,PosCaptY); exit end;

  { Oui, l'utilisateur veut vraiment quitter }
  EffaceEcranTxt; CurseurOff; CoulTxt := 7+0*16;
  EcriTc ('Liste',15+1*16); EcriTc (' v',7+1*16); EcriTcr (Version,14+1*16);
  EcriT ('Crateur: '); EcriTcr ('Haypo ',10);
  EcriT ('Email   : '); EcriTcr (Email,10);
  EcriT ('Sources : '); EcriTcr (PageWeb,10);
  SauteLigne;
  LibereMemAlloue;
  Halt;
end;

function PosChr (ch: char; var Source; long: word) : word; var TmpM: word; begin
  TmpM := 0;
  while (mem[Seg(Source): Ofs(Source)+TmpM]<>Ord(ch)) and (TmpM<long) do
    inc(TmpM);

  if (mem[Seg(Source): Ofs(Source)+TmpM]<>Ord(ch)) or (TmpM=long) then
    PosChr := $FFFF      { Non trouv }
  else
    PosChr := TmpM;      { Trouv }
end;

procedure EcritUneLigneDef; var EffaceEspace: Boolean; begin with Tampon do begin
  TmpO := DefLarg-length(PreTxt);
  EffaceEspace := FALSE;

  { Texte faisant plus d'une ligne ? Oui, alors coupe au premier espace }
  { trouv en fin de ligne }
  if TmpO<Long then begin
    TmpM := TmpO;
    while (Src^[debut +TmpM]<>Ord(' ')) and (1<TmpM) do dec(TmpM);
    if (Src^[debut +TmpM]=Ord(' ')) and (1<TmpM) then begin
      TmpO := TmpM;
      EffaceEspace := TRUE;
    end;
  end else TmpO := Long;

  if TmpO<>0 then begin
    { Copie le texte du tampon dans la variable 'txt' et ajoute le prfixe }
    move (Src^[debut],txt[1],TmpO); txt[0] := chr(TmpO);
    txt := PreTxt+txt;

    { Ecrit le texte  l'cran }
    if DefIY<DefYmax then EcriTxc (PosDefX,DefIY,txt,coul);

    { Ecrit le texte dans le tampon cran }
    with TamponEcran do begin
      index := 0;
      for i := 1 to length(txt) do begin
        TmpLigne[index] := Ord(txt[i]); inc (index);
        TmpLigne[index] := Coul;        inc (index);
      end;

      for i := 1 to (OctetLigneDefEcran-index) shr 1 do begin
        TmpLigne[index] := Ord(' ');  inc (index);
        TmpLigne[index] := CoulActif; inc (index);
      end;

      with CopieXms do begin
        Taille := index;
        SrcHdl := 0;
        SrcOfs := Ptr2Long(Addr(TmpLigne));
        DstHdl := Handle;
        DstOfs := LongInt(Y)*OctetLigneDefEcran;

        CopieMemXms (CopieXms); TestErreurXms ('criture d''une ligne dans le tampon cran');
      end;
    end;

    { Passe un espace ? }
    if EffaceEspace then inc(TmpO);

    { Passe  la ligne suivante }
    inc (debut,TmpO);
    dec (long,TmpO);
  { Ligne vide }
  end else with TamponEcran do begin
    { Ecrit une ligne vide dans le tampon cran }
    index := 0;
    for i := 1 to OctetLigneDefEcran shr 1 do begin
      TmpLigne[index] := Ord(' '); inc (index);
      TmpLigne[index] := coul;     inc (index);
    end;

    with CopieXms do begin
      Taille := OctetLigneDefEcran;
      SrcHdl := 0;
      SrcOfs := Ptr2Long(Addr(TmpLigne));
      DstHdl := Handle;
      DstOfs := Y*OctetLigneDefEcran;

      CopieMemXms (CopieXms); TestErreurXms ('criture d''une ligne dans le tampon cran (2)');
    end;
  end;

  inc (DefIY);
  inc (TamponEcran.Y);
end end;

procedure DecodeDef; var SauveLong: word; begin with Tampon do begin
  { Un retour  la ligne dans ce texte ? }
  while PosChr('|',Src^[Debut],Long)<>$FFFF do begin
    ix := PosChr('|',Src^[Debut],Long);

    { Sauve la longueur de la dfinition avant de la modifier }
    SauveLong := Long-ix-1; Long := ix;

    { Affiche la dfinition }
    repeat EcritUneLigneDef until long=0;

    { Remet la longueur de la dfinition }
    Long := SauveLong;

    inc(debut); { Passe le caractre '|' }
  end;

  { Ecrit le reste du texte }
  repeat EcritUneLigneDef until long=0;
end end;

procedure ChangeNavigation (Actif: Boolean); begin
  if Actif and (TamponEcran.Actif=FALSE) then Actif := FALSE;
  if NavigDsDef=Actif then Exit;
  NavigDsDef := Actif;

  if NavigDsDef then begin
    ColorieZoneTxt (PosCaptX,PosDefY,CaptLarg,DefHaut,CoulActif,CoulFond);
    ColorieZoneTxt (PosDefX,PosDefY,DefLarg,DefHaut,CoulFond,CoulActif);
  end else begin
    ColorieZoneTxt (PosCaptX,PosDefY,CaptLarg,DefHaut,CoulFond,CoulActif);
    ColorieZoneTxt (PosDefX,PosDefY,DefLarg,DefHaut,CoulActif,CoulFond);
  end;
end;

procedure AfficheDef (var TmpListe: ListeType; index: word);
var SauveDebut,SauveLong: Word; SauveCoul: Byte; SauveNavig: Boolean;
begin with TmpListe do with Tampon do begin
  { Cherche l'index de la dfinition }
  i := 0;
  while (Def^[i].index<>index) and (i<NbrDef) do inc (i);

  { Charge la dfinition dans le tampon }
  Tampon.Debut := 0;
  if (Def^[i].index=index) and (i<=NbrDef) then with CopieXms do begin
    Taille := Def^[i].Long;
    SrcHdl := TmpListe.TouteDefHdlXMS;
    SrcOfs := Def^[i].Ofst;
    DstHdl := 0;
    DstOfs := Ptr2Long(Tampon.Src);
    CopieMemXms (CopieXms);

    Tampon.Long := Taille;

    TestErreurXms ('l''affichage des dfinitions');
  end else with Tampon do begin
    txt := TxtIntrouvable;
    move (txt[1],Src^,length(TxtIntrouvable));
    Long := length(TxtIntrouvable);
  end;

  { Quelle couleur utiliser ? }
  Coul := CoulActif;

  { Efface l'ancienne dfinition }
  AttendEcran;
  RemplitZoneTxt (PosDefX,PosDefY,DefLarg,23-PosDefY,' ',coul);

  { Ajuste le tampon cran }
  TamponEcran.Y := 0;

  { Affiche la dfinition }
  DefIY := PosDefY; IntIndex := 0; PreTxt := '';
  repeat
    while PosChr('#',Tampon.Src^[debut],Tampon.Long)<>$FFFF do begin
      ix := PosChr('#',Tampon.Src^[debut],Tampon.Long);

      { Sauve le dbut et longueur modifis de la dfintion }
      SauveDebut := Debut+ix+1; SauveLong := Long-ix-1; Long := ix;

      { Affiche la dfinition }
      DecodeDef;

      { Remet le dbut et longueur de la dfintion }
      Debut := SauveDebut; Long := SauveLong;

      { Saute une ligne (crit une ligne vide) }
      SauveDebut := Debut;
      SauveLong := Long; SauveCoul := Coul;
      PreTxt := '';
      Long := 0;
      EcritUneLigneDef;

      { Ecrit le texte de prsentation de la rubrique }
      Case IntIndex of
        0: txt := 'Entres :';
        1: txt := 'Sorties :';
        2: txt := 'Remarques :';
      else txt := '??? :';
      end;
      Long := length(txt);
      Debut := $FFFE-Long;
      move (txt[1],Tampon.Src^[Debut],Long);

      Coul := CoulSepInt;
      EcritUneLigneDef;

      Tampon.Debut := SauveDebut;
      Tampon.Long  := SauveLong;
      Coul         := SauveCoul;

      Case IntIndex of
        0: PreTxt := #26+' ';
        1: PreTxt := ' ';
      else PreTxt := '' { aucun };
      end; inc (IntIndex);
    end; { de 'While PosChr('#',Tampon...) }
    DecodeDef;
  until long=0;

  { Ajuste le tampon cran }
  with TamponEcran do begin
    NbrLigne := Y;
    if DefHaut<Y then begin
      Dec (Y,DefHaut);
      Actif := TRUE;
    end else begin
      Y := 0;
      Actif := FALSE;
    end;
    Ymax := Y;
    Y := 0;

    NavigDsDef := not Actif;
    ChangeNavigation (Actif);
  end;
end end;

procedure AfficheListeDef (Source: ListeType); begin with Source do begin
  max := DefYmax-PosDefY;
  if max<DefSelect+1 then min := DefSelect+1-max else min := 0;
  if NbrDef<max then max := NbrDef+1;
  if NavigDsDef then coul := CoulFond else coul := CoulActif;

  { Efface la liste des dfinitions disponnibles }
  vram := PosDefY*160;
  AttendEcran; CurseurOff;
  for iy := PosDefY to 22 do begin
    for x := 0 to CaptLarg-2 do begin
      EcrnTxt [vram+x shl 1   ] := Ord(' ');
      EcrnTxt [vram+x shl 1 +1] := Coul;
    end;
    inc(vram,160);
  end;

  { Affiche les 22 dfinitions disponnibles }
  for i := 0 to max-1 do begin
    TmpM := Def^[i+min].index;
    if ModeHexa then begin
      if Mode16b then
        TmpTxt := Hex16(TmpM)
      else
        TmpTxt := Hex8(TmpM);
    end else str(TmpM,TmpTxt);

    if Zero then while length(TmpTxt)<NCaractMax do TmpTxt := '0'+TmpTxt;

    EcriTxc (CaptLarg-1-length(TmpTxt),PosDefY+i,TmpTxt,Coul);
  end;
  ColoriH (0,PosDefY+DefSelect-min,CaptLarg-1,CoulDefSelect);

  { Dessine le curseur de la barre de dfilement }
  EcriTxvc (CaptLarg-1,PosDefY+1,21-PosDefY,'',CoulBarreDfl);
  if NbrDef<>0 then EcriTxc (CaptLarg-1,PosCaptY+3+ DefSelect*(22-2-PosDefY) div NbrDef,'',CoulCurBarDfl);

  PosXY (0,PosCaptY);
  CurseurOn;
end end;

procedure LitListe; begin with Tampon do begin
  txt := '';
  repeat
    txt := '';

    { Sauve la position initiale dans le tampon }
    Debut := Ofst;

    { Cherche le caractre de retour  ligne #13 }
    while (Src^[Ofst]<>13) and (Ofst<Max) do inc (Ofst);

    { Calcule la longueur du texte }
    Long := Ofst-Debut;

    { Passe le retour  la ligen (couple de caractres #13#10) }
    if Ofst<>Max then inc (Ofst,2);

    { Efface les commentaires dans la ligne de texte }
    ix := PosChr(';',Src^[Debut],Long);
    if ix<>$FFFF then Long := ix;

    { Supprime les espaces et tabulations en dbut de ligne }
    while ((Src^[Debut]=Ord(_TAB)) or (Src^[Debut]=Ord(' '))) and (0<>Long) do
      begin inc(debut); dec(long) end;

    { Supprime les espaces en fin de texte }
    while ((Src^[Debut+Long-1]=Ord(_TAB)) or (Src^[Debut+Long-1]=Ord(' '))) and (Long<>0) do
      dec(long);

  until (Long<>0) or (Ofst=Max);
end end;

procedure ErreurChargeLst (TxtErreur: string; var NomFich: string); begin
  EcriTr ('');
  EcriTr ('');
  EcriTcr ('Erreur de chargement de la liste '''+NomFich+''' ! :',14+4*16);
  Ecrit ('> Ligne actuelle : ''');
  CoulTxt := 15; i := 0;
  with Tampon do begin
    if Long=0 then
      EcriTc ('( texte vide )',12)
    else
      while i<Long do begin Ecrit (Chr(Src^[debut+i])); inc(i) end;
  end;
  CoulTxt := 7; EcriTr ('''');
  Ecrit ('> '); EcriTcr (TxtErreur,10);
  LitTouche;
  EcriTr ('');
  LibereMemAlloue;
  Halt;
end;

procedure ChargeListe (var Dest: ListeType; NomFich: string); var DefOfst: word; begin
  { Ajoute l'extension si non incluse }
  if Pos('.',NomFich)=0 then NomFich := NomFich +'.lst';

  { Ouverture du fichier }
  {$I-} Assign (F,NomFich); FileMode := 0; Reset (F,1); {$I+}

  { Vrification des erreurs }
  erreur := IOResult;
  if erreur<>0 then begin
    EffaceEcranTxt;
    EcriTcr ('Fichier liste (.lst) '''+NomFich+''' introuvable :',12);
    EcriTr ('> '+TxtErreurFich(erreur));
    EcriTr ('');
    LibereMemAlloue;
    Halt (erreur);
  end;

  if $FFFF<FileSize(f) then begin
    EffaceEcranTxt;
    EcriTcr ('La liste '''+NomFich+''' a une taille trop importante (>65Ko) !',12);
    EcriTr ('');
    EcriTcr ('Solutions :',15);
    EcriTr ('1) Rduisez la taille de cette liste.');
    EcriTr ('2) Attendez la prochaine version de l''utilitaire ''Liste''. Envoyez-moi un email  '+Email+
               ' pour acclrer la venu de cette fonction.');
    EcriTr ('');
    LibereMemAlloue;
    Halt;
  end;

  with Tampon do begin
    { Initialise les variables }
    Ofst := 0;
    Max := FileSize(F);

    { Copie tout le contenu du fichier dans le tampon de 65 Ko}
    BlockRead (F,Src^,Max);

    { Ferme le fichier }
    Close (f);
  end;

  with TmpListe do begin
    TouteDefHdlXMS := AlloueMemXms (65);
    TestErreurXms ('l''allocation du tampon temporaire pour toutes les dfinitions');
    TouteDefCharge := TRUE;

    TmpL := NbrDefParListeMax*SizeOf(UneDefinition);
    if MemAvail<TmpL then begin
      EffaceEcranTxt;
      EcriTcr ('Pas assez de mmoire libre pour allouer une liste temporaire !',12);
      Ecrit ('(manque '); EcriTnc (TmpL - MemAvail,10); EcriTr (' octets)');
      EcriTr ('');
      LibereMemAlloue;
      Halt (8);
    end;
    GetMem (Def,TmpL);
    DefCharge := TRUE;
    TailleMemAlloue := TmpL;

    { Lit la premire ligne du fichier }
    LitListe; with Tampon do begin move(Src^[Debut],Txt[1],long); Txt[0] := chr((long) and 255) end;

    { Est-ce un fichier au format liste }
    if Copy(txt,1,3)<>'LST' then ErreurChargeLst ('Ce fichier n''est pas un fichier au format ''liste''',NomFich);
    Delete (txt,1,4);

    {=== Lit la version de la liste ===}

    { Convertit la partie avant la virgule (partie haute de la version) }
    Val ( Copy(txt,1,Pos('.',txt)-1),Version,erreur);

    if erreur<>0 then begin
      ErreurChargeLst ('Version incorrecte, entrez un nombre s''il vous plait (caractres 0123456789.)',NomFich);
      LibereMemAlloue;
      Halt;
    end else begin
      { Convertit la partie aprs la virgule (partie basse de la version) }
      Val ( Copy(txt,Pos('.',txt)+1,length(txt)),TmpM,erreur);;
      inc (Version,TmpM shl 8);
    end;

    { Version 1.1 ou 1.2 ? }
    if (Version<>VerFormatLst11) and (Version<>VerFormatLst) then begin
      Str (Version shl 8 shr 8,TmpTxt);
      Str (Version shr 8,txt);
      txt := TmpTxt+'.'+txt;
      ErreurChargeLst ('Version incorrecte (v1.1 ou v1.2 demande) contre '+txt+' ici.',NomFich);
    end;

    { Lit le nom de la liste }
    LitListe; with Tampon do begin move(Src^[Debut],Nom[1],long); Nom[0] := chr(long and 255) end;

    { Lit le texte de prsentation d'une dfinition }
    LitListe; with Tampon do begin
      if 70<long then
        ErreurChargeLst ('Texte de prsentation de la dfinition trop long : 70 caractres maximum.',NomFich);

      move(Src^[Debut],TxtPresentDef[1],long);
      TxtPresentDef[0] := chr(long and 255);
    end;

    { Lit le type d'affichage des index }
    LitListe; with Tampon do ModeHexa := (UpCase(Chr(Src^[Debut]))='H');

    { Lit le format de l'affichage des index : octet/mot }
    LitListe; with Tampon do Mode16b := (UpCase(Chr(Src^[Debut]))='M');

    { Lit le format de l'affichage des index : avec zro(s) ou sans ? }
    LitListe; with Tampon do Zero := (UpCase(Chr(Src^[Debut]))='Z');

    { Lit la page d'intro de la liste }
    if Version=VerFormatLst then with Tampon do begin
      LitListe;

      LongTxtIntro := Long;
      with CopieXms do begin
        Taille := LongTxtIntro;
        if Taille and 1=1 then inc(Taille);
        SrcHdl := 0;
        SrcOfs := Ptr2Long(Tampon.Src) +Tampon.Debut;
        DstHdl := TouteDefHdlXMS;
        DstOfs := 0;
        CopieMemXms (CopieXms);
      end;
      TestErreurXms ('la copie du texte d''introduction dans l''ensemble des dfinitions');
    end else begin
      txt := 'Cette liste ne comporte pas de texte d''introduction, car en est encore  la version 1.1';

      LongTxtIntro := length(txt);
      with CopieXms do begin
        Taille := LongTxtIntro;
        if Taille and 1=1 then inc (Taille);
        SrcHdl := 0;
        SrcOfs := Ptr2Long( Addr(txt[1]) );
        DstHdl := TouteDefHdlXMS;
        DstOfs := 0;
        CopieMemXms (CopieXms);
      end;
      TestErreurXms ('la copie du texte d''introduction (v1.1) dans l''ensemble des dfinitions');
    end;
    DefOfst := LongTxtIntro;
    if DefOfst and 1=1 then inc(DefOfst);

    { Lit les dfinitions une par une }
    NbrDef := 0; LitListe; erreur := 0;
    repeat
      { Lit une ligne }
      with Tampon do
        if PosChr(':',Src^[debut],long)=$FFFF then
          ErreurChargeLst ('Vous avez oubliez le caractre '':'' pour dlimiter l''index de la dfinition !',NomFich)
        else
          NCaractMax := PosChr(':',Src^[debut],long);

      { Copie l'index (5 caractres max) dans la variable 'txt' }
      { et la passe en majuscule                                }
      with Tampon do begin move (Src^[debut],txt[1],NCaractMax); txt[0] := chr(NCaractMax) end;
      ConvertitMajuscule (txt);

      { Non, traduit le texte en dcimal }
      if not ModeHexa then begin
        Val (Txt,DefIndex,erreur);

        if erreur<>0 then
          ErreurChargeLst ('Un nombre s''il vous plait (caractres 0123456789 et ABCDE +h)',NomFich);
      { Oui, traduit l'hxadcimal en dcimal }
      end else begin
        if txt[length(txt)]='H' then Delete(txt,length(txt),1);

        { Mode hxadcimal }
        if Mode16b then
          DefIndex := Str2Hex16(txt)
        else
          DefIndex := Str2Hex8(txt);
      end;

      with Tampon do begin
        inc (Debut,NCaractMax+2);
        dec (Long,NCaractMax+2);
        { Ajuste la longueur pour quelle soit paire }
        if long and 1=1 then begin Tampon.Src^[debut+long] := Ord(' '); inc(long) end;
      end;

      { Sauve l'index et la dfinition }
      Def^[NbrDef].index := DefIndex;
      Def^[NbrDef].Ofst := DefOfst;
      Def^[NbrDef].Long := Tampon.Long;

      with CopieXms do begin
        Taille := Tampon.Long;
        SrcHdl := 0;
        SrcOfs := Ptr2Long(Tampon.Src)+Tampon.Debut;
        DstHdl := TouteDefHdlXMS;
        DstOfs := DefOfst;
        CopieMemXms (CopieXms);
      end;
      TestErreurXms ('la copie d''une dfinition vers l''ensemble des dfinitions');
      inc (DefOfst,Tampon.Long);
      if NbrDef=NbrDefParListeMax then begin
        Str (NbrDefParListeMax,txt);
        StopProgram ('chargement d''une liste','Nombre maximal de dfinition (='+txt+') dpass');
      end else inc (NbrDef);

      LitListe; erreur := 0;
    until Tampon.Long=0;

    { Copie la liste temporaire dans la nouvelle liste }
    Dest.ModeHexa := TmpListe.ModeHexa;
    Dest.Mode16b := TmpListe.Mode16b;
    Dest.Zero := TmpListe.Zero;
    Dest.Taille := DefOfst shr 10+1;
    Dest.NbrDef := TmpListe.NbrDef-1;
    Dest.Version := TmpListe.Version;
    Dest.Nom := TmpListe.Nom;
    Dest.TxtPresentDef := TmpListe.TxtPresentDef;
    Dest.LongTxtIntro := TmpListe.LongTxtIntro;

    { Sauve l'ensemble de toutes les dfinitions }
    Dest.TouteDefHdlXMS := AlloueMemXms (Dest.Taille);
    TestErreurXms ('l''allouage du tampon pour toutes les dfinitions');
    Dest.TouteDefCharge := TRUE;
    with CopieXms do begin
      Taille := DefOfst; if Taille and 1=1 then inc(Taille);
      SrcHdl := TmpListe.TouteDefHdlXMS;
      SrcOfs := 0;
      DstHdl := Dest.TouteDefHdlXMS;
      DstOfs := 0;
      CopieMemXms (CopieXms);
    end;
    TestErreurXms ('la copie entre les deux ensembles de dfinitions');

    { Libere la liste temporaire }
    RendMemXms (TmpListe.TouteDefHdlXMS);
    TestErreurXms ('la libration de la liste temporaire');
    TmpListe.TouteDefCharge := FALSE;

    { Copie les index de dfinition de la   }
    { liste temporaire dans le tampon cran }
    TmpL := NbrDef*SizeOf(UneDefinition);

    with CopieXMS do begin
      Taille := TmpL; if TmpL and 1=1 then inc(TmpL);
      SrcHdl := 0;
      SrcOfs := Ptr2Long (TmpListe.Def);
      DstHdl := TamponEcran.Handle;
      DstOfs := 0;
      CopieMemXms (CopieXms); TestErreurXms ('copie des index de dfinition dans le tampon cran');
    end;

    { Libre la liste des index (plus besoin) }
    FreeMem (TmpListe.Def,NbrDefParListeMax*SizeOf(UneDefinition)); DefCharge := FALSE;

    { Sauve les offsets et index des dfinitions }
    if MemAvail<TmpL then begin
      EffaceEcranTxt;
      EcriTcr ('Pas assez de mmoire libre pour allouer les index de dfinition !',12);
      Ecrit ('(manque '); EcriTnc (TmpL - MemAvail,10); EcriTr (' octets)');
      EcriTr ('');
      LibereMemAlloue;
      Halt (8);
    end;
    GetMem (Dest.Def,TmpL);
    Dest.TailleMemAlloue := TmpL;
    Dest.DefCharge := TRUE;

    { Copie les index de dfinition du tampon cran dans la liste }
    with CopieXMS do begin
      SrcHdl := DstHdl;
      SrcOfs := DstOfs;
      DstHdl := 0;
      DstOfs := Ptr2Long (Dest.Def);
      CopieMemXms (CopieXms); TestErreurXms ('copie des index de dfinition dans le tampon cran');
    end;
  end;
end;

procedure AfficheAide (Aide: TexteDAide); var min,max: byte; begin
  { Vide le tampon du clavier }
  VideTamponClavier;

  { Ecrit l'aide dans le Double-Buffer (page 2 de la mmoire vido) }
  coul := 9+1*16;
  for vram := 0 to 1999 do SavEcrnTxt[vram shl 1+1] := coul;

  Vram := 0;
  SavEcrnTxt[0] := ord(ChDCoinHG);
  for ix := 1 to 78 do SavEcrnTxt[ix shl 1] := Ord(ChDLigneH);
  SavEcrnTxt[158] := ord(ChDCoinHD);
  vram := 24*160;
  SavEcrnTxt[vram] := ord(ChDCoinBG);
  for ix := 1 to 78 do SavEcrnTxt[vram +ix shl 1] := Ord(ChDLigneH);
  SavEcrnTxt[vram+158] := ord(ChDCoinBD);

  vram := 160; coul := 5;
  for iy := 1 to 23 do begin
    vram := iy shl 7 + iy shl 5; coul := 15+1*16;
    SavEcrnTxt[vram] := ord(ChDLigneV); inc (vram,2);

    if Aide[iy].X<0 then begin
      min := (80-length(Aide[iy].txt)) shr 1;
      max := min +length(Aide[iy].txt);
    end else if Aide[iy].X=0 then begin
      min := 0;
      max := 0;
    end else begin
      min := Aide[iy].X;
      max := min +length(Aide[iy].Txt);
    end;

    for ix := 1 to min do begin
      SavEcrnTxt[vram] := 32;
      inc (vram); SavEcrnTxt[vram] := coul; inc (vram);
    end;

    for ix := min+1 to max do begin
      SavEcrnTxt[vram] := ord(Aide[iy].Txt[ix-min]);   inc (vram);
      SavEcrnTxt[vram] := coul and $F0 +Aide[iy].Coul; inc (vram);
    end;

    while (0<(vram+2) mod 160) do begin
      SavEcrnTxt[vram] := 32;
      inc (vram); SavEcrnTxt[vram] := coul; inc (vram);
    end;

    SavEcrnTxt[vram] := ord(ChDLigneV);
  end;

  { Scrolle l'cran vers le double-buffer (page 0 -> 1) }
  vram := 0;
  for i := 0 to 25 do begin
    AttendEcran;
    ChangeDebutAffich (vram);
    inc (vram,80);
  end;

  LitTouche;

  { Scrolle le double-buffer vers l'cran (page 1 -> 0) }
  for iy := 0 to 25 do begin
    dec (vram,80);
    AttendEcran;
    ChangeDebutAffich (vram);
  end;
end;

procedure NavigueMenu (Plus: Integer); begin
  if Plus=-127 then TmpL := 0
  else if Plus=+127 then TmpL := NbrListe-1
  else begin
    TmpL := ListeIndex +Plus;
    if TmpL<0 then TmpL := 0;
    if NbrListe-1<TmpL then TmpL := NbrListe-1;
  end;
  if ListeIndex=TmpL then exit;

  AttendEcran;
  ColoriH (0,ListeIndex,80,CoulFond);
  ListeIndex := TmpL;
  ColoriH (0,ListeIndex,80,CoulMenuSelect);
end;

procedure ChoisitListe; var SauveListeIndex: byte; begin
  SauveListeIndex := ListeIndex;

  { Plus de curseur clignotant }
  CurseurOff;

  { Sauve l'cran }
  move (EcrnTxt,SavEcrnTxt,4000);

  EcriTxhc (0,0,80,' ',CoulMenuListe);
  EcriTxc (-1,0,'Liste des '+Liste[ListeIndex].Nom,CoulMenuSelect);

  { Baisse l'cran en affichant le menu des listes disponnibles }
  vram := 0;
  for i := 0 to NbrListe-1 do begin
    AttendEcran;
    AttendEcran;
    if i<>ListeIndex then begin
      move (EcrnTxt[vram],EcrnTxt[vram+160],(22-i)*160);
      EcriTxhc (0,i,80,' ',CoulFond);
      EcriTxc (-1,i,'Liste des '+Liste[i].Nom,CoulFond);
    end;

    inc (vram,160);
  end;

  { Slection d'une liste au clavier (haut/bas) }
  FinCapture := FALSE;
  repeat
    key := UpCase(LitTouche);
    Case key of
    _DEBUT:     NavigueMenu (-127);
    _PAGEHAUT:  NavigueMenu (-3);
    _HAUT:      NavigueMenu (-1);
    _BAS:       NavigueMenu (+1);
    _PAGEBAS:   NavigueMenu (+3);
    _FIN:       NavigueMenu (+127);

    _F1: begin
      move(SavEcrnTxt,Tampon.Src^,SizeOf(EcranTxt80x25));
      AfficheAide(AideMenuListe);
      move(Tampon.Src^,SavEcrnTxt,SizeOf(EcranTxt80x25));
    end;

    _ECHAPE: begin
      while ListeIndex<>SauveListeIndex do
        if ListeIndex<SauveListeIndex then NavigueMenu (+1) else NavigueMenu (-1);

      FinCapture := TRUE;
    end;

    _ENTREE: FinCapture := TRUE;
    end;
  until FinCapture;
  FinCapture := FALSE;

  { Lve l'cran }
  vram := (NbrListe-1)*160;
  AttendEcran; x := 22;
  for i := NbrListe-1 downto 1 do begin
    if ListeIndex=i then begin dec(vram,160); inc (x) end;

    AttendEcran;
    AttendEcran;
    move (EcrnTxt[vram+160],EcrnTxt[vram],(x-i)*160);
    move (SavEcrnTxt[(23-i)*160],EcrnTxt[22*160],160);

    dec(vram,160);
  end;
  CurseurOn;

  PosXY (0,PosCaptY);
  if key=_ECHAPE then exit;

  { Copie le texte d'intro dans le tampon }
  Tampon.Debut := 0;
  Tampon.Long := Liste[ListeIndex].LongTxtIntro;
  with CopieXms do begin
    Taille := Tampon.Long;
    if Taille and 1=1 then inc(Taille);
    SrcHdl := Liste[ListeIndex].TouteDefHdlXMS;
    SrcOfs := 0;
    DstHdl := 0;
    DstOfs := Ptr2Long(Tampon.Src) +Tampon.Debut;
    CopieMemXms (CopieXms);
  end;
  TestErreurXms ('la lecture du texte d''introduction depuis l''ensemble des dfinitions');

  { Efface la capture et ajoute un 'h' si la capture est en hexa }
  EcriTxhc (PosCaptX,PosCaptY,CaptLarg,' ',CoulCapture);
  if Liste[ListeIndex].ModeHexa then if Liste[ListeIndex].Mode16b then
    EcriTxc (PosCaptX+4,PosCaptY,'h',CoulCapture)
  else
    EcriTxc (PosCaptX+2,PosCaptY,'h',CoulCapture);
  PosXY (0,PosCaptY);

  { Efface le texte de prsentation }
  EcriTxhc (PosPrstX,PosCaptY,PrstLarg,' ',CoulFond);

  { Affiche le texte d'intro }
  PreTxt := '';
  TamponEcran.Y := 0;
  AttendEcran;
  RemplitZoneTxt (PosDefX,PosDefY,DefLarg,23-PosDefY,' ',CoulFond);
  DefIY := PosDefY;
  DecodeDef;

  { Ajuste le tampon cran }
  with TamponEcran do begin
    NbrLigne := Y;
    if DefHaut<Y then begin
      Dec (Y,DefHaut);
      Actif := TRUE;
    end else begin
      Y := 0;
      Actif := FALSE;
    end;
    Ymax := Y;
    Y := 0;

    NavigDsDef := TRUE;
    ChangeNavigation (FALSE);
  end;

  { Affiche la liste des dfinitions disponnibles }
  DefSelect := 0;
  if Liste[ListeIndex].Mode16b then NCaractMax := 5 else NCaractMax := 3;
  AfficheListeDef (Liste[ListeIndex]);
end;

procedure EffaceTamponEcran (NbrLigne: Word); var MaxI: Word; Larg: LongInt; begin
  Larg := LongInt(NbrLigne)*OctetLigneDefEcran;
  if $FFFF<Larg then MaxI := $FFFF else MaxI := Larg;

  index := 0;
  for i := 1 to MaxI shr 1 do begin
    Tampon.Src^[index] := Ord(' '); inc (index);
    Tampon.Src^[index] := CoulFond; inc (index);
  end;

  with CopieXms do begin
    { Efface la premire partie }
    Taille := index;
    SrcHdl := 0;
    SrcOfs := Ptr2Long(Tampon.Src);
    DstHdl := TamponEcran.Handle;
    DstOfs := 0;
    CopieMemXms (CopieXms); TestErreurXms ('effacement du tampon cran');

    { Efface la fin }
    Dec (Larg,MaxI);
    while 0<Larg do begin
      if $FFFF shr 1<Larg then MaxI := $FFFF shr 1 else MaxI := Larg;
      Taille := MaxI; if Taille and 1=1 then inc(Taille);
      Dec (Larg,MaxI);

      CopieMemXms (CopieXms); TestErreurXms ('effacement du tampon cran (2)');
    end;
  end;
end;

procedure AfficheTamponEcran; var MaxI: byte; SauveDstOfs: LongInt; begin
  AttendEcran;
  PosXY (0,PosCaptY);

  if TamponEcran.NbrLigne<TamponEcran.Y+DefHaut then
    MaxI := TamponEcran.NbrLigne-TamponEcran.Y
  else
    MaxI := DefHaut;

  with CopieXms do begin
    SrcOfs := TamponEcran.Y*OctetLigneDefEcran;
    Taille := OctetLigneDefEcran;
    SrcHdl := TamponEcran.Handle;
    DstHdl := 0;
    DstOfs := $B8000000 +PosDefY shl 7 +PosDefY shl 5 +PosDefX shl 1;
  end;

  for iy := 0 to MaxI-1 do with CopieXms do begin
    SauveDstOfs := DstOfs;
    CopieMemXms (CopieXms); TestErreurXms ('effacement du tampon cran');
    DstOfs := SauveDstOfs +160;

    inc (SrcOfs,OctetLigneDefEcran);
  end;
end;

procedure Navigation (Plus: ShortInt); var TmpL: LongInt; begin
  if NavigDsDef then with TamponEcran do begin
    if Actif then begin
      if Plus=-127 then TmpL := 0
      else if Plus=+127 then TmpL := Ymax
      else begin
        TmpL := Y +Plus;
        if TmpL<0 then TmpL := 0;
        if Ymax<TmpL then TmpL := Ymax;
      end;

      if Y=TmpL then exit;

      Y := TmpL;
      AfficheTamponEcran;
    end;
  end else begin
    if Plus=-127 then TmpL := 0
    else if Plus=+127 then TmpL := Liste[ListeIndex].NbrDef
    else begin
      TmpL := DefSelect +Plus;
      if TmpL<0 then TmpL := 0;
      if Liste[ListeIndex].NbrDef<TmpL then TmpL := Liste[ListeIndex].NbrDef;
    end;
    if DefSelect=TmpL then exit;

    DefSelect := TmpL;
    AfficheListeDef (Liste[ListeIndex]);
  end;
end;

procedure Init; begin
  { Vrifie la prsence du driver XMS }
  VerifiePresenceXms;

  EffaceEcranTxt;
  LibereMemAlloueLance := FALSE;

  { Alloue de la mmoire }
  if MemAvail < $FFFF then begin
    EffaceEcranTxt;
    EcriTcr ('Pas assez de mmoire libre pour allouer le tampon de 64 Ko !',12);
    Ecrit ('(manque '); EcriTnc ($FFFF - MemAvail,10); EcriTr (' octets)');
    EcriTr ('');
    LibereMemAlloue;
    Halt (8);
  end;
  GetMem (Tampon.Src,$FFFF); Tampon.Charge := TRUE;

  { Calcule la taille du tampon cran : 65 Ko minimum }
  TmpL := LongInt(NbrLigneDefMax)*OctetLigneDefEcran shr 10 +1;
  if TmpL<65 then TmpL := 65;

  { Alloue le tampon cran et le prpare }
  if MemXmsLibre<TmpL then begin
    Str (TmpL,txt);
    Str (MemXmsLibre,TmpTxt);
    txt := 'libre: '+TmpTxt+' Ko contre '+txt+' Ko demands';
    StopProgramInfo ('allocation du tampon cran','Mmoire XMS libre insuffisante',txt);
  end;

  { Efface le tampon cran }
  with TamponEcran do begin
    Handle := AlloueMemXms (TmpL); TestErreurXms ('allocation du tampon cran');
    EffaceTamponEcran (NbrLigneDefMax);

    Y := 0;
    NbrLigne := 0;
  end;

  { Charge les listes }
  Ecrit ('Chargement des listes ... ');
  for ListeIndex := 0 to NbrListe-1 do begin EcriTn (ListeIndex); ChargeListe (Liste[ListeIndex],NomFichListe[ListeIndex]) end;

  EffaceEcranTxt;

  { Dessine la barre du haut (menu des listes) }
  EcriTxhc (0,1,80,ChDLigneH,CoulCadrHaut);

  { Dessine la liste des dfinitions disponible et le cadre o capturer une  }
  { valeur                                                                   }
  EcriTxhc (0,PosCaptY,80,' ',CoulCapture);
  CoulTxt := CoulCadrCentr;
  EcriTxh (0,PosCaptY+1,80,ChLigneH);
  EcriTxv (CaptLarg,PosCaptY,23-PosCaptY,ChLigneV);
  EcriTx (CaptLarg,PosCaptY+1,'');

  { Dessine la barre de dfilement de la liste des dfinitions disponnibles }
  max := 22-PosDefY;
  EcriTxc (CaptLarg-1,PosDefY,'',CoulCurBarDfl);
  EcriTxc (CaptLarg-1,PosDefY+max,'',CoulCurBarDfl);
  EcriTxvc (CaptLarg-1,PosDefY+1,max-1,'',CoulBarreDfl);

  { Affiche la barre d'aide en bas }
  CoulTxt := CoulCadrBas;
  EcriTxh (0,23,80,ChDLigneH); EcriTxh (0,24,80,' ');
  EcriTxc (-1,24,'Liste v'+Version,CoulTxtBas);
  txt := 'Aide <- F1';        EcriTxc (1,24,txt,CoulTxtBas);
  x := 1+length(txt)+1;       EcriTx (x,23,''); EcriTx (x,24,ChDLigneV);
  txt := 'Echape -> Quitter'; EcriTxc (79-length(txt),24,txt,CoulTxtBas);
  x := 79-1-length(txt)-1;    EcriTx (x,23,''); EcriTx (x,24,ChDLigneV);

  { Efface le fond o seront crit les dfinition }
  RemplitZoneTxt (PosDefX,PosDefY,DefLarg,23-PosDefY,' ',CoulFond);

  { Choisit une liste parmis celles disponnibles }
  CoulTxt := CoulTxt;
  txt := 'Pour connatre les touches de navigation tapez F1';
  EcriTxc (PosDefX +(DefLarg-length(txt)) shr 1,PosDefY +1,txt,CoulActif);
  NavigDsDef := FALSE;
  AfficheListeDef (Liste[0]);
  ListeIndex := 0;
  ChoisitListe;
end;

label Capture;
begin
  Init;

  repeat
Capture:
    erreur := 0;
    DefIndex := 0;

    { Efface la dernire capture }
    EcriTxhc (PosCaptX,PosCaptY,CaptLarg,' ',CoulCapture);

    { Capture le texte en hxadcimal ? Si oui ajoute un 'h'  la fin }
    if Liste[ListeIndex].ModeHexa then if Liste[ListeIndex].Mode16b then
      EcriTxc (PosCaptX+4,PosCaptY,'h',CoulCapture)
    else
      EcriTxc (PosCaptX+2,PosCaptY,'h',CoulCapture);
    PosXY (0,PosCaptY);

    FinCapture := FALSE; txt := ''; CurseurOn;
    repeat
      key := UpCase(LitTouche);

      Case key of
      { Capture d'un index }
      _RETOUR: if length(txt)<>0 then begin
        delete(txt,length(txt),1);
        EcriTxc (length(txt),PosCaptY,' ',CoulCapture);
        PosX (length(txt));
      end;

      '0'..'9','A'..'F','H': if length(txt)<NCaractMax then begin
        txt := txt+key;
        EcriTc (key,CoulCapture);
      end;

      { Dplacement dans la liste des dfinitions }
      _GAUCHE  : ChangeNavigation (FALSE);
      _DROITE  : ChangeNavigation (TRUE);
      _DEBUT   : Navigation (-127);
      _PAGEHAUT: Navigation (-5);
      _HAUT    : Navigation (-1);
      _BAS     : Navigation (+1);
      _PAGEBAS : Navigation (+5);
      _FIN     : Navigation (+127);

      { Fin de la capture ou slection d'une dfinition dans la liste }
      _ENTREE: FinCapture := TRUE;

      { Affiche l'aide }
      _F1: AfficheAide(AideGenerale);

      { Menu des liste }
      _ESPACE: begin ChoisitListe; txt := '' end;

      { Quitter }
      _ECHAPE: Fin;
      end;
    until FinCapture;
    CurseurOff;

    { Aucune capture (slection  l'aide des flche) ? Si oui cre le texte }
    if txt='' then
      if Liste[ListeIndex].ModeHexa then
        txt := Hex16(Liste[ListeIndex].Def^[DefSelect].index)
      else
        str(Liste[ListeIndex].Def^[DefSelect].index,txt);

    { Non, traduit le texte en dcimal }
    if not Liste[ListeIndex].ModeHexa then begin
      Val (txt,DefIndex,erreur);
      if erreur<>0 then begin
        EcriTxc (PosDefX,PosCaptY,'Un nombre s''il vous plait (caractres 0123456789 et ABCDE)',12);
        Goto Capture;
      end;

      str(DefIndex,txt)
    { Oui, traduit l'hxadcimal en dcimal }
    end else begin
      if Liste[ListeIndex].Mode16b then begin
        DefIndex := Str2Hex16(txt);
        txt := Hex16(DefIndex);
      end else begin
        DefIndex := Str2Hex8(txt);
        txt := Hex8(DefIndex);
      end;
    end;

    { Ajoute des zros ? }
    if Liste[ListeIndex].Zero then while length(txt)<NCaractMax do txt := '0'+txt;

    { Ajoute le texte dans le texte de prsentation de la dfinition }
    TmpTxt := Liste[ListeIndex].TxtPresentDef;
    x := Pos('%',TmpTxt);
    TmpTxt := Copy(TmpTxt,1,x-1) +txt+ Copy(TmpTxt,x+1,length(TmpTxt));
    EcriTxc (PosDefX,PosCaptY,TmpTxt,7+0*16);

    { Ecrit la dfinition }
    AfficheDef (Liste[ListeIndex],DefIndex);
  until FALSE;
end.